.model small
.586
.stack

NUM2DEC MACRO num,pBuffer
      mov eax,num
      mov ecx,10
      mov edi,pBuffer
      call NumToStr
ENDM

; Modified version of MASM 6 @ShowStr macro.
; Note that the strOffset argument must be a
; quoted string or a constant.
SHOWSTR MACRO strOffset
      LOCAL  msg, sseg
      IF @InStr(1,strOffset,<!"> ) EQ 1
            sseg  TEXTEQU @CurSeg
            .DATA
            msg   BYTE strOffset,"$"
            @CurSeg ENDS
            sseg  SEGMENT
            mov   dx, OFFSET msg
      ELSE
            mov   dx, strOffset
      ENDIF
      mov   ah,9
      int   21h
ENDM

WAITKEY MACRO
      mov   ah,0
      int   16h
ENDM

.data
      eaxVal      dd 0
      edxVal      dd 0
      vendorID    db 12 dup(0),13,10,"$"
      family      db 12 dup(0),13,10,"$"
	model       db 12 dup(0),13,10,"$"
	stepping    db 12 dup(0),13,10,13,10,"$"
      crlf        db 13,10,"$"
.code
.startup
      xor   eax,eax
      cpuid
      mov   dword ptr[vendorID],ebx
      mov   dword ptr[vendorID+4],edx
      mov   dword ptr[vendorID+8],ecx
      push  eax
      SHOWSTR offset vendorID
	SHOWSTR offset crlf
      pop   eax
      or    eax,eax
      jnz   @F
	; No other input values supported.
      WAITKEY
      .exit
@@:
	; Limit input value to 1 (Pentium circa 1995).
      mov   eax,1
      cpuid
      mov   eaxVal,eax
      mov   edxVal,edx      
      and   eax,0fh
      NUM2DEC eax,offset stepping
      mov   eax,eaxVal
      shr   eax,4
      and   eax,0fh
      NUM2DEC eax,offset model
      mov   eax,eaxVal
      shr   eax,8
      and   eax,0fh
      NUM2DEC eax,offset family

	SHOWSTR "Family   : "
      SHOWSTR offset family
      SHOWSTR "Model    : "
      SHOWSTR offset model
	SHOWSTR "Stepping : "
      SHOWSTR offset stepping	

      test  edxVal,1
      jz    @F
      SHOWSTR "FPU on chip"
      SHOWSTR offset crlf
@@:      
      test  edxVal,100b
      jz    @F
      SHOWSTR "I/O Breakpoints"
      SHOWSTR offset crlf
@@:
      test  edxVal,10000b
      jz    @F
      SHOWSTR "Time Stamp Counter"
      SHOWSTR offset crlf
@@:
      test  edxVal,100000b
      jz    @F
      SHOWSTR "Pentium-CPU-style model specific registers"
      SHOWSTR offset crlf
@@:
      test  edxVal,80h
      jz    @F
      SHOWSTR "Machine Check Exception"
      SHOWSTR offset crlf
@@:
      test  edxVal,100h
      jz    @F
      SHOWSTR "CMPXCHG8B Instruction"
      SHOWSTR offset crlf
@@:
      WAITKEY
      .exit

; ================================================
; This is a MASMized version of the size-optimized
; number to string conversion posted by johnfound.
;************************************
; NumToStr:
;   Converts signed integer value to string.
; NumToStrU:
;   Converts unsigned integer value to string.
;
; EDI - pointer to string buffer
; EAX - Number to convert
; ECX - radix from 2 to $ff
;
; Note: Don't use 1 as radix.
;************************************

NumToStr:
      test  eax,eax
      jns   NumToStrU
      neg   eax
      mov   byte ptr [edi],'-'
      inc   edi

NumToStrU: 
      cmp   eax,ecx
      jb    less

      xor   edx,edx
      div   ecx
      push  edx
      call  NumToStrU
      pop   eax

less:
      cmp   al,0ah
      sbb   al,69h
      das

      mov   [edi],ax
      inc   edi
      ret
; ================================================
end
